gstreamermm 1.10.0

Public Member Functions | Static Public Member Functions | Protected Member Functions | Related Functions | List of all members
Gst::Pipeline Class Reference
gstreamermm Base Classes

A top-level bin with clocking and bus management functionality. More...

`#include <gstreamermm/pipeline.h>`

Inheritance diagram for Gst::Pipeline:
[legend]

## Public Member Functions
| Pipeline (Pipeline&& src) noexcept
Pipeline& | operator= (Pipeline&& src) noexcept
| ~Pipeline () noexcept override
GstPipeline* | gobj ()
| Provides access to the underlying C GObject. More...
const GstPipeline* | gobj () const
| Provides access to the underlying C GObject. More...
GstPipeline* | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs. More...
Glib::RefPtr< Gst::Bus > | get_bus ()
| Gets the Gst::Bus of pipeline. More...
Glib::RefPtr< const Gst::Bus > | get_bus () const
| Gets the Gst::Bus of pipeline. More...
bool | set_clock (const Glib::RefPtr< Gst::Clock >& clock)
| Set the clock for pipeline. More...
Glib::RefPtr< Gst::Clock > | get_clock ()
| Gets the current clock used by pipeline. More...
Glib::RefPtr< const Gst::Clock > | get_clock () const
| Gets the current clock used by pipeline. More...
void | use_clock (const Glib::RefPtr< Gst::Clock >& clock)
| Force pipeline to use the given clock. More...
void | auto_clock ()
| Let pipeline select a clock automatically. More...
void | set_auto_flush_bus (gboolean auto_flush=true)
| Usually, when a pipeline goes from READY to `nullptr` state, it automatically flushes all pending messages on the bus, which is done for refcounting purposes, to break circular references. More...
bool | get_auto_flush_bus () const
| Check if pipeline will automatically flush messages when going to the `nullptr` state. More...
void | set_delay (ClockTime delay)
| Set the expected delay needed for all elements to perform the PAUSED to PLAYING state change. More...
ClockTime | get_delay () const
| Get the configured delay (see set_delay()). More...
Glib::RefPtr< Gst::Clock > | get_pipeline_clock ()
| Gets the current clock used by pipeline. More...
Glib::RefPtr< const Gst::Clock > | get_pipeline_clock () const
| Gets the current clock used by pipeline. More...
void | set_latency (Gst::ClockTime latency)
| Sets the latency that should be configured on the pipeline. More...
Gst::ClockTime | get_latency () const
| Gets the latency that should be configured on the pipeline. More...
Glib::PropertyProxy< guint64 > | property_latency ()
| Latency to configure on the pipeline. More...
Glib::PropertyProxy_ReadOnly< guint64 > | property_latency () const
| Latency to configure on the pipeline. More...
Glib::PropertyProxy< bool > | property_auto_flush_bus ()
| Whether to automatically flush the pipeline's bus when going from READY into `nullptr` state. More...
Glib::PropertyProxy_ReadOnly< bool > | property_auto_flush_bus () const
| Whether to automatically flush the pipeline's bus when going from READY into `nullptr` state. More...
Glib::PropertyProxy< ClockTime > | property_delay ()
| Expected delay needed for elements to spin up to PLAYING in nanoseconds. More...
Glib::PropertyProxy_ReadOnly< ClockTime > | property_delay () const
| Expected delay needed for elements to spin up to PLAYING in nanoseconds. More...
Public Member Functions inherited from Gst::Bin
| Bin (Bin&& src) noexcept
Bin& | operator= (Bin&& src) noexcept
| ~Bin () noexcept override
GstBin* | gobj ()
| Provides access to the underlying C GObject. More...
const GstBin* | gobj () const
| Provides access to the underlying C GObject. More...
GstBin* | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs. More...
Glib::RefPtr< Gst::Bin > | add (const Glib::RefPtr< Gst::Element >& element)
| Adds the given element to the bin. More...
Glib::RefPtr< Gst::Bin > | remove (const Glib::RefPtr< Gst::Element >& element)
| Removes the element from the bin, unparenting it as well. More...
Glib::RefPtr< Gst::Element > | get_element (const Glib::ustring& name)
| Gets the element with the given name from a bin. More...
Glib::RefPtr< const Gst::Element > | get_element (const Glib::ustring& name) const
| Gets the element with the given name from a bin. More...
Glib::RefPtr< Gst::Element > | get_element_recurse_up (const Glib::ustring& name)
| Gets the element with the given name from this bin. More...
Glib::RefPtr< const Gst::Element > | get_element_recurse_up (const Glib::ustring& name) const
| Gets the element with the given name from this bin. More...
Glib::RefPtr< Gst::Element > | get_element (GType interface)
| Looks for an element inside the bin that implements the given interface. More...
Glib::RefPtr< const Gst::Element > | get_element (GType interface) const
| Looks for an element inside the bin that implements the given interface. More...
Glib::RefPtr< Gst::GhostPad > | add_ghost_pad (const Glib::RefPtr< Gst::Element >& element, const Glib::ustring& pad_name, const Glib::ustring& name=Glib::ustring())
| Adds a ghost pad to the bin using an element's static pad as a target. More...
Glib::RefPtr< Gst::Pad > | find_unlinked_pad (PadDirection dir)
| Recursively looks for elements with an unlinked pad of the given direction within the specified bin and returns an unlinked pad if one is found, or `nullptr` otherwise. More...
Glib::RefPtr< const Gst::Pad > | find_unlinked_pad (PadDirection dir) const
| Recursively looks for elements with an unlinked pad of the given direction within the specified bin and returns an unlinked pad if one is found, or `nullptr` otherwise. More...
Gst::Iterator< Gst::Element > | iterate_elements ()
| Gets an iterator for the elements in this bin. More...
Gst::Iterator< const Gst::Element > | iterate_elements () const
| Gets an iterator for the elements in this bin. More...
Gst::Iterator< Gst::Element > | iterate_recurse ()
| Gets an iterator for the elements in this bin. More...
Gst::Iterator< const Gst::Element > | iterate_recurse () const
| Gets an iterator for the elements in this bin. More...
Gst::Iterator< Gst::Element > | iterate_sorted ()
| Gets an iterator for the elements in this bin in topologically sorted order. More...
Gst::Iterator< const Gst::Element > | iterate_sorted () const
| Gets an iterator for the elements in this bin in topologically sorted order. More...
Gst::Iterator< Gst::Element > | iterate_sources ()
| Gets an iterator for all elements in the bin that have the Gst::ELEMENT_FLAG_SOURCE flag set. More...
Gst::Iterator< const Gst::Element > | iterate_sources () const
| Gets an iterator for all elements in the bin that have the Gst::ELEMENT_FLAG_SOURCE flag set. More...
Gst::Iterator< Gst::Element > | iterate_sinks ()
| Gets an iterator for all elements in the bin that have the Gst::ELEMENT_FLAG_SINK flag set. More...
Gst::Iterator< const Gst::Element > | iterate_sinks () const
| Gets an iterator for all elements in the bin that have the Gst::ELEMENT_FLAG_SINK flag set. More...
Gst::Iterator< Gst::Element > | iterate_by_interface (GType iface)
| Looks for all elements inside the bin that implements the given interface. More...
Gst::Iterator< const Gst::Element > | iterate_by_interface (GType iface) const
| Looks for all elements inside the bin that implements the given interface. More...
bool | sync_children_states ()
| Synchronizes the state of every child of bin with the state of bin. More...
bool | recalculate_latency ()
| Query bin for the current latency using and reconfigures this latency to all the elements with a LATENCY event. More...
Glib::ListHandle< Glib::RefPtr< Gst::Element > > | get_children () const
| Gets the bin's list of children. More...
guint32 | get_children_cookie () const
| Gets the children cookie. More...
int | get_num_children () const
| Gets the number of children in the bin. More...
Glib::RefPtr< Gst::Bus > | get_child_bus ()
| Gets the internal bus for handling child messages. More...
Glib::RefPtr< const Gst::Bus > | get_child_bus () const
Glib::ListHandle< Glib::RefPtr< Gst::Message > > | get_messages () const
| Gets the bin's queued and cached messages. More...
bool | get_polling () const
| Gets whether the bin is currently calculating its state. More...
bool | get_clock_dirty () const
| Gets whether the bin needs to select a new clock. More...
Glib::RefPtr< Gst::Clock > | get_provided_clock ()
| Gets the last clock selected. More...
Glib::RefPtr< const Gst::Clock > | get_provided_clock () const
Glib::RefPtr< Gst::Element > | get_clock_provider ()
| Gets the element that provided provided_clock. More...
Glib::RefPtr< const Gst::Element > | get_clock_provider () const
Glib::PropertyProxy< bool > | property_async_handling ()
| The bin will handle Asynchronous state changes. More...
Glib::PropertyProxy_ReadOnly< bool > | property_async_handling () const
| The bin will handle Asynchronous state changes. More...
Glib::PropertyProxy< bool > | property_message_forward ()
| Forwards all children messages. More...
Glib::PropertyProxy_ReadOnly< bool > | property_message_forward () const
| Forwards all children messages. More...
Glib::SignalProxy< void, const Glib::RefPtr< Gst::Element >& > | signal_element_added ()
Glib::SignalProxy< void, const Glib::RefPtr< Gst::Element >& > | signal_element_removed ()
Glib::SignalProxy< bool > | signal_do_latency ()
virtual bool | add_element_vfunc (const Glib::RefPtr< Gst::Element >& element)
| Method to add an element to a bin. More...
virtual bool | remove_element_vfunc (const Glib::RefPtr< Gst::Element >& element)
| Method to remove an element from a bin. More...
virtual void | handle_message_vfunc (const Glib::RefPtr< Gst::Message >& message)
| Method to handle a message from the children. More...
Public Member Functions inherited from Gst::Element
| Element (Element&& src) noexcept
Element& | operator= (Element&& src) noexcept
| ~Element () noexcept override
GstElement* | gobj ()
| Provides access to the underlying C GObject. More...
const GstElement* | gobj () const
| Provides access to the underlying C GObject. More...
GstElement* | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs. More...
Glib::RefPtr< Gst::Element > | link (const Glib::RefPtr< Gst::Element >& dest)
| Links this source element to the dest element. More...
bool | add_pad (const Glib::RefPtr< Gst::Pad >& pad)
| Adds a pad (link point) to element. More...
void | create_all_pads ()
| Creates a pad for each pad template that is always available. More...
Glib::RefPtr< Gst::Pad > | create_compatible_pad (const Glib::RefPtr< const Gst::Pad >& pad, const Glib::RefPtr< const Gst::Caps >& caps)
| Looks for an unlinked pad to which the given pad can link. More...
Glib::RefPtr< Gst::PadTemplate > | get_compatible_pad_template (const Glib::RefPtr< const Gst::PadTemplate >& compattempl)
| Retrieves a pad template from element that is compatible with compattempl. More...
Glib::RefPtr< const Gst::PadTemplate > | get_compatible_pad_template (const Glib::RefPtr< const Gst::PadTemplate >& compattempl) const
| Retrieves a pad template from element that is compatible with compattempl. More...
Glib::RefPtr< Gst::Pad > | get_request_pad (const Glib::ustring& name)
| Retrieves a pad from the element by name (e.g. "src_\\%d"). More...
Glib::RefPtr< Gst::Pad > | request_pad (const Glib::RefPtr< Gst::PadTemplate >& templ, const Glib::ustring& name, const Glib::RefPtr< const Gst::Caps >& caps)
| Retrieves a request pad from the element according to the provided template. More...
Glib::RefPtr< Gst::Pad > | request_pad (const Glib::RefPtr< Gst::PadTemplate >& templ, const Glib::ustring& name)
| A request_pad() convenience overload. More...
Glib::RefPtr< Gst::Pad > | request_pad (const Glib::RefPtr< Gst::PadTemplate >& templ, const Glib::RefPtr< const Gst::Caps >& caps)
| A request_pad() convenience overload. More...
Glib::RefPtr< Gst::Pad > | request_pad (const Glib::RefPtr< Gst::PadTemplate >& templ)
| A request_pad() convenience overload. More...
Glib::RefPtr< Gst::Pad > | get_static_pad (const Glib::ustring& name)
| Retrieves a pad from element by name. More...
Glib::RefPtr< const Gst::Pad > | get_static_pad (const Glib::ustring& name) const
| Retrieves a pad from element by name. More...
void | no_more_pads ()
| Use this function to signal that the element does not expect any more pads to show up in the current pipeline. More...
void | release_request_pad (const Glib::RefPtr< Gst::Pad >& pad)
| Makes the element free the previously requested pad as obtained with get_request_pad(). More...
bool | remove_pad (const Glib::RefPtr< Gst::Pad >& pad)
| Removes pad from element. More...
Gst::Iterator< Gst::Pad > | iterate_pads ()
| Retrieves an iterator of element's pads. More...
Gst::Iterator< const Gst::Pad > | iterate_pads () const
| Retrieves an iterator of element's pads. More...
Gst::Iterator< Gst::Pad > | iterate_sink_pads ()
| Retrieves an iterator of element's sink pads. More...
Gst::Iterator< const Gst::Pad > | iterate_sink_pads () const
| Retrieves an iterator of element's sink pads. More...
Gst::Iterator< Gst::Pad > | iterate_src_pads ()
| Retrieves an iterator of element's source pads. More...
Gst::Iterator< const Gst::Pad > | iterate_src_pads () const
| Retrieves an iterator of element's source pads. More...
void | unlink (const Glib::RefPtr< Gst::Element >& dest)
| Unlinks all source pads of the source element with all sink pads of the sink element to which they are linked. More...
void | set_context (const Glib::RefPtr< Gst::Context >& context)
| Sets the context of the element. More...
bool | link_pads (const Glib::ustring& srcpadname, const Glib::RefPtr< Gst::Element >& dest, const Glib::ustring& destpadname)
| Links the two named pads of the source and destination elements. More...
void | unlink_pads (const Glib::ustring& srcpadname, const Glib::RefPtr< Gst::Element >& dest, const Glib::ustring& destpadname)
| Unlinks the two named pads of the source and destination elements. More...
bool | link_pads (const Glib::ustring& srcpadname, const Glib::RefPtr< Gst::Element >& dest, const Glib::ustring& destpadname, const Glib::RefPtr< Gst::Caps >& filter)
| Links the two named pads of the source and destination elements. More...
bool | link_pads (const Glib::ustring& srcpadname, const Glib::RefPtr< Gst::Element >& dest, const Glib::ustring& destpadname, PadLinkCheck flags)
| Links the two named pads of the source and destination elements. More...
Glib::RefPtr< Gst::Element > | link (const Glib::RefPtr< Gst::Element >& dest, const Glib::RefPtr< Gst::Caps >& filter)
| Links src to dest using the given caps as filtercaps. More...
void | set_base_time (ClockTime time)
| Set the base time of an element. More...
ClockTime | get_base_time () const
| Returns the base time of the element. More...
void | set_start_time (Gst::ClockTime time)
| Set the start time of an element. More...
Gst::ClockTime | get_start_time () const
| Returns the start time of the element. More...
void | set_bus (const Glib::RefPtr< Gst::Bus >& bus)
| Sets the bus of the element. More...
Glib::RefPtr< Gst::Bus > | get_bus ()
| Returns the bus of the element. More...
Glib::RefPtr< const Gst::Bus > | get_bus () const
| Returns the bus of the element. More...
Glib::RefPtr< Gst::ElementFactory > | get_factory ()
| Retrieves the factory that was used to create this element. More...
Glib::RefPtr< const Gst::ElementFactory > | get_factory () const
| Retrieves the factory that was used to create this element. More...
bool | set_clock (const Glib::RefPtr< Gst::Clock >& clock)
| Sets the clock for the element. More...
Glib::RefPtr< Gst::Clock > | get_clock ()
| Gets the currently configured clock of the element. More...
Glib::RefPtr< const Gst::Clock > | get_clock () const
| Gets the currently configured clock of the element. More...
Glib::RefPtr< Gst::Clock > | provide_clock ()
| Get the clock provided by the given element. More...
Glib::RefPtr< const Gst::Clock > | provide_clock () const
| Get the clock provided by the given element. More...
StateChangeReturn | set_state (State state)
| Sets the state of the element. More...
StateChangeReturn | get_state (State& state, State& pending, ClockTime timeout) const
| Gets the state of the element. More...
bool | set_locked_state (gboolean locked_state)
| Locks the state of an element, so state changes of the parent don't affect this element anymore. More...
bool | is_locked_state () const
| Checks if the state of an element is locked. More...
void | abort_state ()
| Abort the state change of the element. More...
StateChangeReturn | continue_state (StateChangeReturn ret)
| Commit the state change of the element and proceed to the next pending state if any. More...
void | lost_state ()
| Brings the element to the lost state. More...
bool | sync_state_with_parent ()
| Tries to change the state of the element to the same as its parent. More...
StateChangeReturn | change_state (StateChange transition)
| Perform transition on element. More...
void | post_message (int code, int line, MessageType type=Gst::MESSAGE_INFO, const Glib::QueryQuark& domain=get_core_error_quark(), const Glib::ustring& text=Glib::ustring(), const Glib::ustring& debug=Glib::ustring(), const Glib::ustring& file=Glib::ustring(), const Glib::ustring& function=Glib::ustring())
| Post an error, warning or info message on the bus from inside an element. More...
bool | post_message (Glib::RefPtr< Gst::Message >&& message)
| Post a message on the element's Gst::Bus. More...
bool | query (const Glib::RefPtr< Gst::Query >& query) const
| Performs a query on the given element. More...
bool | query_convert (Gst::Format src_format, gint64 src_val, Format dest_format, gint64& dest_val) const
| Queries an element to convert src_val in src_format to dest_format. More...
bool | query_position (Gst::Format format, gint64& cur) const
| Queries an element (usually top-level pipeline or playbin element) for the stream position in nanoseconds. More...
bool | query_position (Gst::Format format) const
| A query_position() convenience overload. More...
bool | query_duration (Gst::Format format, gint64& duration) const
| Queries an element (usually top-level pipeline or playbin element) for the total stream duration in nanoseconds. More...
bool | query_duration (Gst::Format format) const
| A query_duration() convenience overload. More...
bool | seek (Format format, SeekFlags seek_flags, gint64 seek_pos)
| Simple API to perform a seek on the given element, meaning it just seeks to the given position relative to the start of the stream. More...
bool | seek (double rate, Format format, SeekFlags flags, SeekType cur_type, gint64 cur, SeekType stop_type, gint64 stop)
| Sends a seek event to an element. More...
bool | send_event (Glib::RefPtr< Gst::Event >&& event)
| Sends an event to an element. More...
bool | send_event (const Glib::RefPtr< Gst::Event >& event)
| A send_event() convenience overload. Allows to re-use event parameter after function call. More...
Glib::RefPtr< Gst::Context > | get_context (const Glib::ustring& context_type)
| Gets the context with context_type set on the element or `nullptr`. More...
Glib::RefPtr< Gst::Context > | get_context_unlocked (const Glib::ustring& context_type)
| Gets the context with context_type set on the element or `nullptr`. More...
std::vector< Glib::RefPtr< Gst::Context > > | get_contexts ()
| Gets the contexts set on the element. More...
Glib::SignalProxy< void > | signal_no_more_pads ()
Glib::SignalProxy< void, const Glib::RefPtr< Gst::Pad >& > | signal_pad_added ()
Glib::SignalProxy< void, const Glib::RefPtr< Gst::Pad >& > | signal_pad_removed ()
virtual void | release_pad_vfunc (const Glib::RefPtr< Gst::Pad >& pad)
| Called when a request pad is to be released. More...
virtual Glib::RefPtr< Gst::Pad > | request_new_pad_vfunc (Glib::RefPtr< Gst::PadTemplate > templ, const Glib::ustring& name, const Glib::RefPtr< const Gst::Caps >& caps)
| Called when a new pad is requested. More...
virtual StateChangeReturn | get_state_vfunc (State& state, State& pending, ClockTime timeout) const
| Get the state of the element. More...
virtual StateChangeReturn | set_state_vfunc (State state)
| Set a new state on the element. More...
virtual StateChangeReturn | change_state_vfunc (StateChange transition)
| Called by set_state to perform an incremental state change. More...
virtual void | state_changed_vfunc (Gst::State oldstate, Gst::State newstate, Gst::State pending)
| Called immediately after a new state was set. More...
virtual void | set_bus_vfunc (const Glib::RefPtr< Gst::Bus >& bus)
| Set a Gst::Bus on the element. More...
virtual Glib::RefPtr< Gst::Clock > | provide_clock_vfunc ()
| Gets the Gst::Clock provided by the element. More...
virtual bool | set_clock_vfunc (const Glib::RefPtr< Gst::Clock >& clock)
| Set the Gst::Clock on the element. More...
virtual bool | send_event_vfunc (const Glib::RefPtr< Gst::Event >& event)
| Send a Gst::Event to the element. More...
virtual bool | query_vfunc (const Glib::RefPtr< Gst::Query >&query) const
| Perform a Gst::Query on the element. More...
virtual void | set_context_vfunc (const Glib::RefPtr< Gst::Context >& context)
| Set a Gst::Context on the element. More...
virtual bool | post_message_vfunc (const Glib::RefPtr< Gst::Message >& message)
| Called when a message is posted on the element. More...
Glib::RefPtr< Gst::PadTemplate > | get_pad_template (const Glib::ustring& factory_name) const
template<typename T >
Glib::RefPtr< Gst::Element > | property (const Glib::ustring& name, const T& value)
| Sets specified property. More...
Public Member Functions inherited from Gst::Object
| Object (Object&& src) noexcept
Object& | operator= (Object&& src) noexcept
| ~Object () noexcept override
GstObject* | gobj ()
| Provides access to the underlying C GObject. More...
const GstObject* | gobj () const
| Provides access to the underlying C GObject. More...
GstObject* | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs. More...
bool | is_element () const
bool | is_element_factory () const
bool | is_pad () const
bool | is_pad_template () const
bool | is_bin () const
guint32 | get_flags () const
| Returns the entire set of flags for the object. More...
bool | set_name (const Glib::ustring& name)
| Sets the name of object, or gives object a guaranteed unique name (if name is `nullptr`). More...
Glib::ustring | get_name () const
| Returns a copy of the name of object. More...
bool | set_parent (const Glib::RefPtr< Gst::Object >& parent)
| Sets the parent of object to parent. More...
Glib::RefPtr< Gst::Object > | get_parent ()
| Returns the parent of object. More...
Glib::RefPtr< const Gst::Object > | get_parent () const
| Returns the parent of object. More...
void | unparent ()
| Clear the parent of object, removing the associated reference. More...
void | set_control_rate (Gst::ClockTime control_rate)
| Change the control-rate for this object. More...
Gst::ClockTime | get_control_rate () const
| Obtain the control-rate for this object. More...
Gst::ClockTime | suggest_next_sync () const
| Returns a suggestion for timestamps where buffers should be split to get best controller results. More...
bool | sync_values (Gst::ClockTime timestamp)
| Sets the properties of the object, according to the Gst::ControlSources that (maybe) handle them and for the given timestamp. More...
void | set_control_bindings_disabled (bool disabled)
| This function is used to disable all controlled properties of the object for some time, i.e. sync_values() will do nothing. More...
bool | has_asctive_control_bindings () const
| Check if the object has an active controlled properties. More...
bool | has_ancestor (const Glib::RefPtr< const Gst::Object >& ancestor) const
| Check if object has an ancestor ancestor somewhere up in the hierarchy. More...
bool | has_as_ancestor (const Glib::RefPtr< Gst::Object >& ancestor) const
| Check if object has an ancestor ancestor somewhere up in the hierarchy. More...
bool | has_as_parent (const Glib::RefPtr< Gst::Object >& parent) const
| Check if parent is the parent of object. More...
Glib::ustring | get_path_string ()
| Generates a string describing the path of object in the object hierarchy. More...
Glib::PropertyProxy< Glib::ustring > | property_name ()
| The name of the object. More...
Glib::PropertyProxy_ReadOnly< Glib::ustring > | property_name () const
| The name of the object. More...
Glib::PropertyProxy< Glib::RefPtr< Gst::Object > > | property_parent ()
| The parent of the object. More...
Glib::PropertyProxy_ReadOnly< Glib::RefPtr< Gst::Object > > | property_parent () const
| The parent of the object. More...
Glib::SignalProxy< void, const Glib::RefPtr< Gst::Object >&, GParamSpec* > | signal_deep_notify ()
int | get_refcount () const
Public Member Functions inherited from Glib::Object
| Object (const Object &)=delete
Object & | operator= (const Object &)=delete
| Object (Object &&src) noexcept
Object & | operator= (Object &&src) noexcept
void * | get_data (const QueryQuark &key)
void | set_data (const Quark &key, void *data)
void | set_data (const Quark &key, void *data, DestroyNotify notify)
void | remove_data (const QueryQuark &quark)
void * | steal_data (const QueryQuark &quark)
Glib::RefPtr< Glib::Object > | wrap (GObject *object, bool take_copy=false)
Public Member Functions inherited from Glib::ObjectBase
| ObjectBase (const ObjectBase &)=delete
ObjectBase & | operator= (const ObjectBase &)=delete
void | set_property_value (const Glib::ustring &property_name, const Glib::ValueBase &value)
void | get_property_value (const Glib::ustring &property_name, Glib::ValueBase &value) const
void | set_property (const Glib::ustring &property_name, const PropertyType &value)
void | get_property (const Glib::ustring &property_name, PropertyType &value) const
void | connect_property_changed (const Glib::ustring &property_name, const sigc::slot< void > &slot)
void | connect_property_changed (const Glib::ustring &property_name, sigc::slot< void > &&slot)
sigc::connection | connect_property_changed_with_return (const Glib::ustring &property_name, const sigc::slot< void > &slot)
sigc::connection | connect_property_changed_with_return (const Glib::ustring &property_name, sigc::slot< void > &&slot)
void | freeze_notify ()
void | thaw_notify ()
virtual void | reference () const
virtual void | unreference () const
GObject * | gobj ()
const GObject * | gobj () const
GObject * | gobj_copy () const
Public Member Functions inherited from sigc::trackable
| trackable () noexcept
| trackable (const trackable &src) noexcept
| trackable (trackable &&src)
| ~trackable ()
void | add_destroy_notify_callback (void *data, func_destroy_notify func) const
void | notify_callbacks ()
trackable & | operator= (const trackable &src)
trackable & | operator= (trackable &&src)
void | remove_destroy_notify_callback (void *data) const
Public Member Functions inherited from Gst::ChildProxy
| ChildProxy (ChildProxy&& src) noexcept
ChildProxy& | operator= (ChildProxy&& src) noexcept
| ~ChildProxy () noexcept override
GstChildProxy* | gobj ()
| Provides access to the underlying C GObject. More...
const GstChildProxy* | gobj () const
| Provides access to the underlying C GObject. More...
guint | get_children_count () const
| Gets the number of child objects this parent contains. More...
Glib::RefPtr< Gst::Object > | get_child (const Glib::ustring& name)
| Looks up a child element by the given name. More...
Glib::RefPtr< const Gst::Object > | get_child (const Glib::ustring& name) const
| Looks up a child element by the given name. More...
Glib::RefPtr< Glib::Object > | get_child (guint index)
| Fetches a child by its number. More...
Glib::RefPtr< const Glib::Object > | get_child (guint index) const
| Fetches a child by its number. More...
bool | lookup (const Glib::ustring& name, Glib::RefPtr< Glib::Object >& target, GParamSpec*& pspec)
| Looks up which object and ParamSpec would be effected by the given name. More...
Glib::RefPtr< Gst::ChildProxy > | get_proxy_property (const Glib::ustring& name, Glib::ValueBase& value)
| Gets a single property using the Gst::ChildProxy mechanism. More...
Glib::RefPtr< const Gst::ChildProxy > | get_proxy_property (const Glib::ustring& name, Glib::ValueBase& value) const
| Gets a single property using the Gst::ChildProxy mechanism. More...
Glib::RefPtr< Gst::ChildProxy > | set_proxy_property (const Glib::ustring& name, const Glib::ValueBase& value)
| Sets a single property using the Gst::ChildProxy mechanism. More...
void | child_added (const Glib::RefPtr< Gst::Object >& child, const Glib::ustring& name)
| Emits the "child-added" signal. More...
void | child_removed (const Glib::RefPtr< Gst::Object >& child, const Glib::ustring& name)
| Emits the "child-removed" signal. More...
Glib::SignalProxy< void, const Glib::RefPtr< Gst::Object >&, const Glib::ustring& > | signal_child_added ()
Glib::SignalProxy< void, const Glib::RefPtr< Gst::Object >&, const Glib::ustring& > | signal_child_removed ()
virtual Glib::RefPtr< Glib::Object > | get_child_by_name_vfunc (const Glib::ustring& name) const
| Virtual method to fetch the child by name. More...
virtual Glib::RefPtr< Glib::Object > | get_child_by_index_vfunc (guint index) const
| Virtual method to fetch the child by index. More...
virtual guint | get_children_count_vfunc () const
| Virtual method to get the children count. More...
Public Member Functions inherited from Glib::Interface
| Interface ()
| Interface (Interface &&src) noexcept
Interface & | operator= (Interface &&src) noexcept
| Interface (const Glib::Interface_Class &interface_class)
| Interface (GObject *castitem)
| ~Interface () noexcept override
| Interface (const Interface &)=delete
Interface & | operator= (const Interface &)=delete
GObject * | gobj ()
const GObject * | gobj () const

## Static Public Member Functions
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...
static Glib::RefPtr< Pipeline > | create (const Glib::ustring& name)
| Create a new pipeline with the given name. More...
static Glib::RefPtr< Pipeline > | create ()
| Create a new pipeline with a unique generic name. More...
Static Public Member Functions inherited from Gst::Bin
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...
static Glib::RefPtr< Bin > | create (const Glib::ustring& name)
| Creates a new bin with the given name. More...
static Glib::RefPtr< Bin > | create ()
| Creates a new bin with a unique generic name. More...
Static Public Member Functions inherited from Gst::Element
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...
Static Public Member Functions inherited from Gst::Object
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...
static bool | check_uniqueness (const Glib::ListHandle< const Gst::Object >& list, const Glib::ustring& name)
| Checks to see if there is any object named name in list. More...
Static Public Member Functions inherited from Gst::ChildProxy
static void | add_interface (GType gtype_implementer)
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...

## Protected Member Functions
| Pipeline (const Glib::ustring& name)
| Pipeline ()
Protected Member Functions inherited from Gst::Bin
| Bin (const Glib::ustring& name)
| Bin ()
virtual void | on_element_added (const Glib::RefPtr< Gst::Element >& element)
| This is a default handler for the signal signal_element_added(). More...
virtual void | on_element_removed (const Glib::RefPtr< Gst::Element >& element)
| This is a default handler for the signal signal_element_removed(). More...
virtual bool | on_do_latency ()
| This is a default handler for the signal signal_do_latency(). More...
Protected Member Functions inherited from Gst::Element
virtual void | on_no_more_pads ()
| This is a default handler for the signal signal_no_more_pads(). More...
virtual void | on_pad_added (const Glib::RefPtr< Gst::Pad >& new_pad)
| This is a default handler for the signal signal_pad_added(). More...
virtual void | on_pad_removed (const Glib::RefPtr< Gst::Pad >& old_pad)
| This is a default handler for the signal signal_pad_removed(). More...
Protected Member Functions inherited from Gst::Object
virtual void | on_deep_notify (const Glib::RefPtr< Gst::Object >& prop_object, GParamSpec* prop)
| This is a default handler for the signal signal_deep_notify(). More...
Protected Member Functions inherited from Glib::Object
| Object ()
| Object (const Glib::ConstructParams &construct_params)
| Object (GObject *castitem)
| ~Object () noexcept override
Protected Member Functions inherited from Glib::ObjectBase
| ObjectBase ()
| ObjectBase (const char *custom_type_name)
| ObjectBase (const std::type_info &custom_type_info)
| ObjectBase (ObjectBase &&src) noexcept
ObjectBase & | operator= (ObjectBase &&src) noexcept
virtual | ~ObjectBase () noexcept=0
void | initialize (GObject *castitem)
void | initialize_move (GObject *castitem, Glib::ObjectBase *previous_wrapper)
Protected Member Functions inherited from Gst::ChildProxy
| ChildProxy ()
| You should derive from this class to use it. More...
virtual void | on_child_added (const Glib::RefPtr< Gst::Object >& object, const Glib::ustring& name)
| This is a default handler for the signal signal_child_added(). More...
virtual void | on_child_removed (const Glib::RefPtr< Gst::Object >& object, const Glib::ustring& name)
| This is a default handler for the signal signal_child_removed(). More...

## Related Functions
(Note that these are not member functions.)
Glib::RefPtr< Gst::Pipeline > | wrap (GstPipeline* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...
Related Functions inherited from Gst::Bin
Glib::RefPtr< Gst::Bin > | wrap (GstBin* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...
Related Functions inherited from Gst::Element
Glib::RefPtr< Gst::Element > | wrap (GstElement* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...
Related Functions inherited from Gst::Object
Glib::RefPtr< Gst::Object > | wrap (GstObject* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...
Related Functions inherited from Gst::ChildProxy
Glib::RefPtr< Gst::ChildProxy > | wrap (GstChildProxy* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...

## Additional Inherited Members
Public Types inherited from Glib::Object
typedef void(*)(gpointer data | DestroyNotify)
Public Types inherited from sigc::trackable
typedef internal::func_destroy_notify | func_destroy_notify

## Detailed Description

A top-level bin with clocking and bus management functionality.

A Gst::Pipeline is a special Gst::Bin used as the toplevel container for the filter graph. The Gst::Pipeline will manage the selection and distribution of a global Gst::Clock as well as provide a Gst::Bus to the application. It will also implement a default behavour for managing seek events (see Gst::Element::seek()).

create() is used to create a pipeline. when the pipeline is destroyed all its resources including all added Gst::Element objects are destroyed.

Elements are added and removed from the pipeline using the Gst::Bin methods like Gst::Bin::add() and Gst::Bin::remove() (see Gst::Bin).

Before changing the state of the Gst::Pipeline (see Gst::Element) a Gst::Bus can be retrieved with get_bus(). This bus can then be used to receive Gst::Message from the elements in the pipeline.

By default, a Gst::Pipeline will automatically flush the pending Gst::Bus messages when going to the NULL state to ensure that no circular references exist when no messages are read from the Gst::Bus. This behaviour can be changed with set_auto_flush_bus().

When the Gst::Pipeline performs the PAUSED to PLAYING state change it will select a clock for the elements. The clock selection algorithm will by default select a clock provided by an element that is most upstream (closest to the source). For live pipelines (ones that return Gst::STATE_CHANGE_NO_PREROLL from the Gst::Element::set_state() call) this will select the clock provided by the live source. For normal pipelines this will select a clock provided by the sinks (most likely the audio sink). If no element provides a clock, a default Gst::SystemClock is used.

The clock selection can be controlled with the use_clock() method, which will enforce a given clock on the pipeline. With auto_clock() the default clock selection algorithm can be restored.

A Gst::Pipeline maintains a stream time for the elements. The stream time is defined as the difference between the current clock time and the base time. When the pipeline goes to READY or a flushing seek is performed on it, the stream time is reset to 0. When the pipeline is set from PLAYING to PAUSED, the current clock time is sampled and used to configure the base time for the elements when the pipeline is set to PLAYING again.

When sending a flushing seek event to a Gst::Pipeline (see Gst::Element::seek()), it will make sure that the pipeline is properly PAUSED and resumed as well as set the new stream time to 0 when the seek succeeded.

Last reviewed on 2016-06-06 (1.8.0)

## Constructor & Destructor Documentation

## ◆ Pipeline() [1/3]

Gst::Pipeline::Pipeline | ( | Pipeline&& | src | ) |
| noexcept

## ◆ ~Pipeline()

Gst::Pipeline::~Pipeline | ( |  | ) |
| override noexcept

## ◆ Pipeline() [2/3]

Gst::Pipeline::Pipeline | ( | const Glib::ustring & | name | ) |
| explicit protected

## ◆ Pipeline() [3/3]

Gst::Pipeline::Pipeline | ( |  | ) |
| protected

## Member Function Documentation

## ◆ auto_clock()

void Gst::Pipeline::auto_clock | ( |  | ) |

Let pipeline select a clock automatically.

This is the default behaviour.

Use this function if you previous forced a fixed clock with use_clock() and want to restore the default pipeline clock selection algorithm.

MT safe.

## ◆ create() [1/2]

static Glib::RefPtr<Pipeline> Gst::Pipeline::create | ( |  | ) |
| static

Create a new pipeline with a unique generic name.

Returns
  Newly created Gst::Pipeline. MT safe.

Examples
  basics/bus.cc, and basics/dynamic_pads.cc.

## ◆ create() [2/2]

static Glib::RefPtr<Pipeline> Gst::Pipeline::create | ( | const Glib::ustring & | name | ) |
| static

Create a new pipeline with the given name.

Parameters

  name | Name of new pipeline.

Returns
  Newly created Gst::Pipeline. MT safe.

## ◆ get_auto_flush_bus()

bool Gst::Pipeline::get_auto_flush_bus | ( |  | ) | const

Check if pipeline will automatically flush messages when going to the `nullptr` state.

Returns
  Whether the pipeline will automatically flush its bus when going from READY to `nullptr` state or not.

MT safe.

## ◆ get_bus() [1/2]

Glib::RefPtr<Gst::Bus> Gst::Pipeline::get_bus | ( |  | ) |

Gets the Gst::Bus of pipeline.

The bus allows applications to receive Gst::Message packets.

Returns
  A Gst::Bus, unref after usage.

MT safe.

## ◆ get_bus() [2/2]

Glib::RefPtr<const Gst::Bus> Gst::Pipeline::get_bus | ( |  | ) | const

Gets the Gst::Bus of pipeline.

The bus allows applications to receive Gst::Message packets.

Returns
  A Gst::Bus, unref after usage.

MT safe.

## ◆ get_clock() [1/2]

Glib::RefPtr<Gst::Clock> Gst::Pipeline::get_clock | ( |  | ) |

Gets the current clock used by pipeline.

Users of object oriented languages should use get_pipeline_clock() to avoid confusion with Gst::Element::get_clock() which has a different behavior.

Unlike Gst::Element::get_clock(), this function will always return a clock, even if the pipeline is not in the PLAYING state.

Returns
  A Gst::Clock, unref after usage.

## ◆ get_clock() [2/2]

Glib::RefPtr<const Gst::Clock> Gst::Pipeline::get_clock | ( |  | ) | const

Gets the current clock used by pipeline.

Users of object oriented languages should use get_pipeline_clock() to avoid confusion with Gst::Element::get_clock() which has a different behavior.

Unlike Gst::Element::get_clock(), this function will always return a clock, even if the pipeline is not in the PLAYING state.

Returns
  A Gst::Clock, unref after usage.

## ◆ get_delay()

ClockTime Gst::Pipeline::get_delay | ( |  | ) | const

Get the configured delay (see set_delay()).

Returns
  The configured delay.

MT safe.

## ◆ get_latency()

Gst::ClockTime Gst::Pipeline::get_latency | ( |  | ) | const

Gets the latency that should be configured on the pipeline.

See set_latency().

Returns
  Latency to configure on the pipeline or GST_CLOCK_TIME_NONE.

## ◆ get_pipeline_clock() [1/2]

Glib::RefPtr<Gst::Clock> Gst::Pipeline::get_pipeline_clock | ( |  | ) |

Gets the current clock used by pipeline.

Unlike Gst::Element::get_clock(), this function will always return a clock, even if the pipeline is not in the PLAYING state.

Returns
  A Gst::Clock, unref after usage.

## ◆ get_pipeline_clock() [2/2]

Glib::RefPtr<const Gst::Clock> Gst::Pipeline::get_pipeline_clock | ( |  | ) | const

Gets the current clock used by pipeline.

Unlike Gst::Element::get_clock(), this function will always return a clock, even if the pipeline is not in the PLAYING state.

Returns
  A Gst::Clock, unref after usage.

## ◆ get_type()

static GType Gst::Pipeline::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

## ◆ gobj() [1/2]

GstPipeline* Gst::Pipeline::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

## ◆ gobj() [2/2]

const GstPipeline* Gst::Pipeline::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

## ◆ gobj_copy()

GstPipeline* Gst::Pipeline::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

## ◆ operator=()

Pipeline& Gst::Pipeline::operator= | ( | Pipeline&& | src | ) |
| noexcept

## ◆ property_auto_flush_bus() [1/2]

Glib::PropertyProxy< bool > Gst::Pipeline::property_auto_flush_bus | ( |  | ) |

Whether to automatically flush the pipeline's bus when going from READY into `nullptr` state.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_auto_flush_bus() [2/2]

Glib::PropertyProxy_ReadOnly< bool > Gst::Pipeline::property_auto_flush_bus | ( |  | ) | const

Whether to automatically flush the pipeline's bus when going from READY into `nullptr` state.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_delay() [1/2]

Glib::PropertyProxy< ClockTime > Gst::Pipeline::property_delay | ( |  | ) |

Expected delay needed for elements to spin up to PLAYING in nanoseconds.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_delay() [2/2]

Glib::PropertyProxy_ReadOnly< ClockTime > Gst::Pipeline::property_delay | ( |  | ) | const

Expected delay needed for elements to spin up to PLAYING in nanoseconds.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ property_latency() [1/2]

Glib::PropertyProxy< guint64 > Gst::Pipeline::property_latency | ( |  | ) |

Latency to configure on the pipeline.

Returns
  A PropertyProxy that allows you to get or set the value of the property, or receive notification when the value of the property changes.

## ◆ property_latency() [2/2]

Glib::PropertyProxy_ReadOnly< guint64 > Gst::Pipeline::property_latency | ( |  | ) | const

Latency to configure on the pipeline.

Returns
  A PropertyProxy_ReadOnly that allows you to get the value of the property, or receive notification when the value of the property changes.

## ◆ set_auto_flush_bus()

void Gst::Pipeline::set_auto_flush_bus | ( | gboolean | auto_flush = `true` | ) |

Usually, when a pipeline goes from READY to `nullptr` state, it automatically flushes all pending messages on the bus, which is done for refcounting purposes, to break circular references.

This means that applications that update state using (async) bus messages (e.g. do certain things when a pipeline goes from PAUSED to READY) might not get to see messages when the pipeline is shut down, because they might be flushed before they can be dispatched in the main thread. This behaviour can be disabled using this function.

It is important that all messages on the bus are handled when the automatic flushing is disabled else memory leaks will be introduced.

MT safe.

Parameters

  auto_flush | Whether or not to automatically flush the bus when the pipeline goes from READY to `nullptr` state.

## ◆ set_clock()

bool Gst::Pipeline::set_clock | ( | const Glib::RefPtr< Gst::Clock >& | clock | ) |

Set the clock for pipeline.

The clock will be distributed to all the elements managed by the pipeline.

Parameters

  clock | The clock to set.

Returns
  `true` if the clock could be set on the pipeline. `false` if some element did not accept the clock.

MT safe.

## ◆ set_delay()

void Gst::Pipeline::set_delay | ( | ClockTime | delay | ) |

Set the expected delay needed for all elements to perform the PAUSED to PLAYING state change.

delay will be added to the base time of the elements so that they wait an additional delay amount of time before starting to process buffers and cannot be Gst::CLOCK_TIME_NONE.

This option is used for tuning purposes and should normally not be used.

MT safe.

Parameters

  delay | The delay.

## ◆ set_latency()

void Gst::Pipeline::set_latency | ( | Gst::ClockTime | latency | ) |

Sets the latency that should be configured on the pipeline.

Setting GST_CLOCK_TIME_NONE will restore the default behaviour of using the minimum latency from the LATENCY query. Setting this is usually not required and the pipeline will figure out an appropriate latency automatically.

Setting a too low latency, especially lower than the minimum latency from the LATENCY query, will most likely cause the pipeline to fail.

Parameters

  latency | Latency to configure.

## ◆ use_clock()

void Gst::Pipeline::use_clock | ( | const Glib::RefPtr< Gst::Clock >& | clock | ) |

Force pipeline to use the given clock.

The pipeline will always use the given clock even if new clock providers are added to this pipeline.

If clock is `nullptr` all clocking will be disabled which will make the pipeline run as fast as possible.

MT safe.

Parameters

  clock | The clock to use.

## Friends And Related Function Documentation

## ◆ wrap()

Glib::RefPtr< Gst::Pipeline > wrap | ( | GstPipeline * | object,
|  | bool | take_copy = `false`
| ) |  |
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.